#include <iostream>
using namespace std;
#include "Pvs.h"

KdPvsData *
KdPvs::Find(KdNode *node)
{
  KdPvsMap::iterator i = mEntries.find(node);
  if (i != mEntries.end()) {
    //    cout<<node<<" "<<(*i).first<<" "<<(*i).second.mVisibleSamples<<endl;
    return &(*i).second;
  } else
    return NULL;
}

int
KdPvs::AddNodeSample(KdNode *node)
{
  int result;
  
  KdPvsData *data = Find(node);
  if (data) {
    data->mVisibleSamples++;
    result = 0;
  } else {
    mEntries[node] = KdPvsData(1);
    result = 1;
  }
  return  result;
}


void
KdPvs::GetData(const int index,
	       KdNode *&node,
	       KdPvsData &data
	       )
{
  KdPvsMap::iterator i = mEntries.begin();
  for (int k = 0; k!=index && i != mEntries.end(); i++, k++);

  node = (*i).first;
  data = (*i).second;
}
